import requests
from requests_aws4auth import AWS4Auth
import boto3
import click


class RequestAws:
    def __init__(self, region, service):
        self.credentials = boto3.Session().get_credentials()
        self.region = region
        self.service = service
        self.awsauth = AWS4Auth(self.credentials.access_key, self.credentials.secret_key, self.region, 's3')

    def request(self, url, filename='eel.sh', request_method='get'):
        res = requests.request(method=request_method, url=url, auth=self.awsauth)
        if res.status_code == 200:
            with open(filename, "wb") as f:
                f.write(res.content)
            return {
                'code': 200,
                'message': "Download complete!"
            }
        else:
            return {
                'code': res.status_code,
                'error': 'some error, pls contact you administrator!'
            }


# import click


@click.command()
@click.option('--url', help='Number of greetings.')
@click.option('--region', default='cn-north-1', help='service region')
@click.option('--service', default='s3', help='service name')
def main(url, region, service):
    request_aws = RequestAws(region, service)
    response = request_aws.request(url=url)
    print(response)

# if __name__ == "__main__":
#     main()

# os.system(f"chmod +x {filename}")
# print("install")
# os.system(f"./{filename}")
# print("complete")
# # print(a)

## url改成命令行
## 封装成命令，打包成pip包
## 测试能不能下载带身份的S3
## python里执行二进制
